/*
title:		common.ms
path:		$scripts\AShimScripts\functions
autor:		AShim (Titov Mykhaylo)
e-mail:		ashim@rambler.ru
date:		february 2010
version:	1.0
*/

global AShim_common
if (AShim_common != true) do
(
	-- def infinum
	global inf = 1.0 / 0.0
	
	-- down = p1 up = p2 left < 0 right > 0
	-- set line Ax+By-C=0
	global AShim_getABCLine
	fn AShim_getABCLine p1 p2 = (
		A = p2.y - p1.y
		B = p1.x - p2.x
		C = p1.x * p2.y - p2.x * p1.y
		A2B2 = sqrt (A * A + B * B)
		#(A / A2B2, B / A2B2, C / A2B2)
	)
	
	global AShim_getABCPerpendicular
	fn AShim_getABCPerpendicular ABC = (
		#(-ABC[2], ABC[1], 0)
	)
	
	-- get distance to line Ax+By-C=0
	global AShim_getDistToABCLine
	fn AShim_getDistToABCLine ABC p = (
		ABC[1] * p.x + ABC[2] * p.y - ABC[3]
	)
	
	print "AShimScripts: common.ms has been loaded."
	AShim_common = true
)
